#include <reg552.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <rtx51.h>

#define	WaitForEver	0xFF

#define	MBX_REG_K		0
#define	MBX_REG_V		1
#define	MBX_DISPL		7

#define	DISPLAY			0
#define	ADC					1
#define	REGULATOR_K	2
#define	REGULATOR_V	3
#define	CLOCK				4
#define	SERVOK			5
#define	SERVOV			6
#define	PUMPSK			7
#define	PUMPSV			8

#define ADCS 0x08
#define ADCI 0x10
#define ADEX 0x20

#define WLE 0x10
#define INTERVAL 250							          									//Watchdog cca. 200ms
#define Watchdog ((PCON|=WLE),(T3=0x100-INTERVAL))

#define	Count_Sensor	4

enum Switch{OFF=0,ON=1};
enum Teploty{tk=0,tks=1,tv=2,tex=3};													//tk je skutocna hodnota kurenia, tv je skutocna teplota vody, tvv je ziadana hodnota teplej vody, tkv=tex*krivka , tex je externa teplota prostredia, tks je kurenie spiatocka, ...........
enum Dni{Pon=1,Uto=2,Str=3,Stv=4,Pia=5,Sob=6,Ned=7};
enum Riadky {Riadok1=0x00,Riadok2=0x40,Riadok3=0x14,Riadok4=0x54};
enum eMenu {Info0,Info1,Info2,Info3,Info4,Info5,InfoTe,InfoTs,SetKp,SetKTi,SetKTd,SetVp,SetVTi,SetVTd,SetdT,Servis};

typedef	xdata struct
{
 int CH[Count_Sensor];
}
AD_Converter;

typedef xdata struct
{
 unsigned char Hod,Min,Sek,Des,Den,Mes,Rok,DenNum;
}
Time;

typedef xdata struct
{
 unsigned char Hod,Min;
}
Interval;

typedef struct																						//Predtym bolo len "typedef struct" a nefungovalo to dobre ... !!!
{
 char Reset;
 int SetPosition,ActualPosition,dPosition;
 int E0,E1,E2;
 int Servo_Min,Servo_Max,Hysterezia;
 int Tkomfort,Tutlm,deltaT,Tmin,Tmax,Tlimit;
 float dT,Kp,Ti,Td,KA,KB,KC,Y0,Y1;
 unsigned char Comfort,Pump,Vykurovacia_Krivka;
 Interval Od[7],Do[7];
}volatile Parameter;

//-------------------------------------------------------------------------------------------------------------------------------------------
#define RegdT					0.250												//Interval vzorkovania pre regulator dT=200ms, rozsah je od 15ms do 254ms
//-------------------------------------------------------------------------------------------------------------------------------------------
#define RegKKp				0.500
#define RegKTi				30.00
#define RegKTd				1.123E-2
#define RegKSrvMin		0
#define RegKSrvZdvih	12
#define RegKSrvPosun	15
#define	RegKSrvMax		(RegKSrvZdvih*RegKSrvPosun)	//Natocenie o 180 za 180 sekund, Zdvih=12mm, Posun=15s/mm = 12*15=180s
#define RegKSrvHyster	2
#define RegKTkomfort	25
#define RegKTutlm 		23
#define RegKTdT				(RegKTkomfort-RegKTutlm)
#define RegKTmin			0
#define RegKTmax			90
#define RegKTlimit		13
#define RegKKrivka		10
//-------------------------------------------------------------------------------------------------------------------------------------------
#define RegVKp				0.800
#define RegVTi				30.00
#define RegVTd				1.456E-2
#define RegVSrvMin		0
#define RegVSrvZdvih	12
#define RegVSrvPosun	3
#define	RegVSrvMax		(RegVSrvZdvih*RegVSrvPosun)	//Natocenie o 180 za 36 sekund, Zdvih=12mm, Posun=3s/mm = 12*3=36s
#define RegVSrvHyster	2
#define RegVTkomfort	55
#define RegVTutlm 		50
#define RegVTdT				(RegVTkomfort-RegVTutlm)
#define RegVTmin			0
#define RegVTmax			50
#define RegVTlimit		13
#define RegVKrivka		10
//-------------------------------------------------------------------------------------------------------------------------------------------
code	Parameter			FactoryK = 
										 {
										  'N',																																																																	//Reset
											0,0,0,																																																																//SetPosition,ActualPosition,dPosition
											0,0,0,																																																																//E0,E1,E2,											
											RegKSrvMin,RegKSrvMax,RegKSrvHyster,																																																	//Servo_Min,Servo_Max,Hysterezia
											RegKTkomfort,RegKTutlm,RegKTdT,RegKTmin,RegKTmax,RegKTlimit,																																					//Tkomfort,Tutlm,deltaT,Tmin,Tmax,Tlimit
											RegdT,RegKKp,RegKTi,RegKTd,(RegKKp*(1.0+RegdT/(2.0*RegKTi))),(RegKKp*(1.0-RegdT/(2.0*RegKTi))),(RegKKp*(RegKTd/RegdT)),0.000,0.000,		//dT,Kp,Ti,Td,KA,KB,KC,Y0,Y1
											ON,ON,RegKKrivka,																																																											//Comfort,Pump,Vykurovacia_Krivka
											{{4,30},{4,30},{4,30},{4,30},{4,30},{5,30},{5,30}},																																										//Intervaly od do
											{{22,00},{22,00},{22,00},{22,00},{22,00},{22,00},{22,00}}																																							//Intervaly od do
										 },
										FactoryV = 
										 {
										  'N',
											0,0,0,
											0,0,0,
											RegVSrvMin,RegVSrvMax,RegVSrvHyster,
											RegVTkomfort,RegVTutlm,RegVTdT,RegVTmin,RegVTmax,RegVTlimit,
											RegdT,RegVKp,RegVTi,RegVTd,(RegVKp*(1.0+RegdT/(2.0*RegVTi))),(RegVKp*(1.0-RegdT/(2.0*RegVTi))),(RegVKp*(RegVTd/RegdT)),0.000,0.000,
											ON,ON,RegVKrivka,
											{{3,30},{3,30},{3,30},{3,30},{3,30},{5,30},{5,30}},
											{{22,00},{22,00},{22,00},{22,00},{22,00},{22,00},{22,00}}
										 };

xdata AD_Converter	Value;
xdata	AD_Converter	*MessageToSend,*ReceivedMessage;
xdata unsigned char *MsgEEToSendK,*MsgEEToSendV;
xdata	Parameter			RegK,RegV;
xdata	Time Cas;

#define NumMemBlocks	1																				//Definujem [n] pouzitych pamatovych blokov, aby nerobilo chyby musi byt o jeden alokovany blok viac !?
#define	SizeMemBlock	sizeof(AD_Converter)										//Velkost pouzivaneho packetu v strukture ...
#define	SizeMemPool		NumMemBlocks*(2+SizeMemBlock)						//(Header+sizeof(AD_Converter)*n)
xdata unsigned char 	MemoryPool[SizeMemPool];								//MemoryPool je niekedy lepsie definovat na pevnej adrese ale uVision robi problemy pri simulacii, doslova vypne niektore tasky akoby pretiekla pamat a poskodila enviroment ...

#define NumEEBlocks		2																				//Definujem [n] pouzitych pamatovych blokov, aby nerobilo chyby musi byt o jeden alokovany blok viac !?
#define	SizeEEBlock		sizeof(Parameter)												//Velkost pouzivaneho packetu v strukture ...
#define	SizeEEPool		NumEEBlocks*(2+SizeEEBlock)							//(Header+sizeof(Parameter)*n)
xdata unsigned char 	EEMemoryPool[SizeEEPool];								//EEprommemoryPool je niekedy lepsie definovat na pevnej adrese ale uVision robi problemy pri simulacii, doslova vypne niektore tasky akoby pretiekla pamat a poskodila enviroment ...

#define AddrDS1624A	0x90																			//Adresa pre DS1621,DS1624,DS1631 - tzv. CONTROL_BYTE
#define AddrMC24C32	0xA0

typedef enum {Jan=1,Feb=2,Mar=3,Apr=4,May=5,Jun=6,Jul=7,Aug=8,Sep=9,Oct=10,Nov=11,Dec=12} Month;
typedef enum {Mon=1,Tue=2,Wed=3,Thu=4,Fri=5,Sat=6,Sun=7} Weekend;

extern void Write_Eprom_AT24C32(unsigned char, unsigned int, unsigned char);
extern unsigned char Read_Eprom_AT24C32(unsigned char, unsigned int);

extern code signed char Ekviterm[14][101];
extern code char Tab0[0x400];
extern code char Tab1[0x400];

extern xdata unsigned char String[LCD_Size+2];
extern void Bar(unsigned int);
extern void LCD_Init(void);
extern void LCD_Goto(unsigned char);
extern void LCD_Write_String(char*);
extern void Delay(char);
extern void Reset(void);
extern void Init_Serial(void);
extern unsigned int Conversion(void);
extern unsigned int ADC_Conversion(unsigned char);
extern unsigned int Get_Int_Temp(unsigned char);

bit LED;

xdata char inline[16];             													//storage for command input line
extern void getline(char xdata*, unsigned char);

code char display_menu[] = 
   "+--------------------------------------------------------------+\n"
   "+      HEATING CONTROLLER with RTX51 by Diversant Software     +\n"
   "+- prikaz -+--  zapis ---+- popis funkcie zariadenia ----------+\n"
   "|    0     |      -      |  Vypis stavu regulatora             |\n"
   "|    1     |      -      |  Kurenie - stav                     |\n"
   "|    2     |      -      |  Tepla voda - nastavenie            |\n"
   "|    3     |      -      |  Stav servoventilov                 |\n"
   "|    4     |      -      |  Zaloha parametrov do EEPROM        |\n"
   "|    5     |      -      |  Obnova parametrov z EEPROM         |\n"	 
   "|    6     |      -      |  Teplota vonkajsia - okolia         |\n"
   "|    7     |      -      |  Teplota systemu v regulatore       |\n"	 
   "|    8     |      -      |  Prenos udajov do PC cez RS232      |\n"	 
   "|    9     |      -      |                                     |\n"
   "|    X     |     0-13    |  Ekvitermicka vykurovacia krivka    |\n"
   "|    K     |      -      |  Konstanta K regulatora K/V         |\n"
   "|    I     |      -      |  Konstanta I regulatora K/V         |\n"
   "|    D     |      -      |  Konstanta D regulatora K/V         |\n"
	 "|    V     |      -      |  Vzorkovanie regulatora dT[ms]      |\n"
   "|    T     |  HH:MM:SS   |  Nastav cas v regulatore            |\n"
   "|    Y     |  DD.MM.RR.d |  Nastav datum v regulatore          |\n"	 
   "|    A     |  HH:MM:d    |  Nastav cas zaciatku komfortu       |\n"	 	 
   "|    B     |  HH:MM:d    |  Nastav cas konca komfortu          |\n"
   "|    R     |     Y/N     |  Reset systemu - vynulovanie        |\n"	 	 	 	 
   "|    /     |      -      |  Prepni konf. rezim KURENIE/VODA    |\n"	 
   "|    *     |      -      |  Obnovenie tovarenskych nastaveni ! |\n"	 	 
   "+----------+-------------+-------------------------------------+\n";

int T;

bit test;

#ifdef ADINT

void ADC_Interrupt(void) interrupt 10 using 2
{
 signed char RtxCompletion;
 RtxCompletion=isr_send_signal(ADC);
}

#endif

#pragma REGISTERBANK (3)

void Adc(void) _task_ ADC _priority_ 3
{
 signed char RtxCompletion;
 unsigned char Channel;
 #ifdef ADINT
 //RtxCompletion=os_attach_interrupt(10);
 RtxCompletion=os_enable_isr(10);
 #endif
 T=-25;
 while(1)
  {
	 Watchdog;
	 switch(RtxCompletion=os_wait(K_IVL,(unsigned char)(RegK.dT*1000),NULL))
	  {
		 case	TMO_EVENT	:	LED=ON;
											for(Channel=0x00; Channel<Count_Sensor; Channel++)
											 {
												ADCON=Channel;																																			//Vyber kanalu pre prevod 0..7
												ADCON|=ADCS;																																				//Spustim prevod, bolo tu ADCON|=ADEX+ADCS;
												test=1;
												#ifdef ADINT
												RtxCompletion=os_wait(K_INT+K_SIG,0xFF,NULL);
												#else
												while(!(ADCON&ADCI));
												#endif
												ADCON^=ADCI;																																				//Zrusim priznak prevodu AD prevodnika
												test=0;
												switch(Channel)
												 {
													case	tex		: Value.CH[Channel]=(int)Tab0[Conversion()];													//Prevediem na teplotu od -50C do +50C
																				Value.CH[Channel]=T; 																								//-20C je vonkajsia teplota ziadana a k nej prinalezi podla krivky teplota navysena ...
																				break;																															
													default			:	Value.CH[Channel]=(int)Tab1[Conversion()];													//Prevediem na teplotu od 0C do +100C
																				//Value.CH[Channel]=AD_Norm(Conversion(),0,100);
																				//Value.CH[Channel]=Tab[Conversion()];															//Prevediem na teplotu od 0C do 100C
																				break;																				
												 }
											 }
											memcpy(MessageToSend,&Value,SizeMemBlock);
											RtxCompletion=os_send_message(MBX_REG_K,(unsigned int)MessageToSend,5);								//Ak RtxCompletion=OK sprava je odoslana mailbox-u, RtxCompletion=NOT_OK sprava nie je odoslana mailbox-u ...
											RtxCompletion=os_send_message(MBX_REG_V,(unsigned int)MessageToSend,5); 
											LED=OFF;
											break;
		 case	SIG_EVENT	:	break;
		 case	MSG_EVENT	:	break;
		}
	}
}

#pragma REGISTERBANK (0)

#define	K	10

void Regulator_K(void) _task_ REGULATOR_K _priority_ 2
{
 signed char RtxCompletion;
 t_rtx_onetasktab RTX51_Task;
 unsigned int Counter;
 memcpy(&RegK,&FactoryK,sizeof(RegK));
 PWMP=0x20;
/* 
 RegK.Reset='N';
 RegK.dT=RegdT;
 RegK.Tmin=0;
 RegK.Tmax=90;																								//Obmedzenie teploty vystupneho okruhu Tmin..Tmax, Tk je teplota kurenia ...
 RegK.Tutlm=23;																								//Nastavenie znizenej teploty T pre kurenie, na izbovu teplotu 22C
 RegK.Tkomfort=25;																						//Nastavenie komfortnej teploty T pre kurenie, na izbovu teplotu 25C
 RegK.Tlimit=13;																							//Od Tlimit=13C zacnem vykurovat ....
 RegK.Kp=RegKKp;																							//Proporcionalna konstanta Kp
 RegK.Ti=RegKTi;																							//Integracna konstanta Ti, je potrebne ju prehodnotit pri zmene serva ...
 RegK.Td=RegKTd;																							//Derivacna konstanta Td, ovplyvnuje strmost narastu pri zmene reg. odchylky 
 RegK.E0=RegK.E1=RegK.E2=0;
 RegK.KA=(RegK.Kp*(1.0+RegK.dT/(2.0*RegK.Ti)));								//Konstanta KA prirastkoveho regulatora
 RegK.KB=(RegK.Kp*(1.0-RegK.dT/(2.0*RegK.Ti)));								//Konstanta KB prirastkoveho regulatora
 RegK.KC=(RegK.Kp*(RegK.Td/RegK.dT));					    						//Konstanta KC prirastkoveho regulatora 
 RegK.Y0=RegK.Y1=0.000;
 RegK.Servo_Min=0;																						//V sekundach !!!
 RegK.Servo_Max=180;																					//Natocenie o 180 za 180 sekund, Zdvih=12mm, Posun=15s/mm = 12*15=180s
 RegK.Pump=ON;																								//Zapnutie obehoveho cerpadla ... 
 memcpy(&RegK.Od,&FactoryK.Od,sizeof(RegK.Od));								//Kopirujem rozsah komfortu ...
 memcpy(&RegK.Do,&FactoryK.Do,sizeof(RegK.Do));								//Kopirujem rozsah komfortu ... 
 RegK.Vykurovacia_Krivka=10;																	//Korekcia teploty pre kurenie pomocou vykurovacej krivky ...
*/ 
 while(1)
  {
	 switch(RtxCompletion=os_wait(K_SIG+K_MBX+MBX_REG_K,WaitForEver,(unsigned int xdata*)&ReceivedMessage))
	  {
		 case	MSG_EVENT	:	RegK.deltaT=(RegK.Tkomfort-RegK.Tutlm);
											switch(RegK.Comfort)
											 {
											  case	ON	:	RegK.E0=(int)Ekviterm[RegK.Vykurovacia_Krivka][ReceivedMessage->CH[tex]-(RegK.Tkomfort-20)+50]-ReceivedMessage->CH[tk]; break;	//Ziadana teplota prepocitana z vonkajsej teploty [tex] a teplota vypocitana z vykurovacej krivky ...
												case	OFF	:	RegK.E0=(int)Ekviterm[RegK.Vykurovacia_Krivka][ReceivedMessage->CH[tex]+(RegK.Tutlm-20)+50]-ReceivedMessage->CH[tk]; break;
											 }	
											if(ReceivedMessage->CH[tk]>=RegK.Tmax) {RegK.Y0=RegK.Y1; RegK.E0=RegK.E1=RegK.E2=0;}	//Obmedzenie na teplotu Tmin..Tmax
											RegK.Y0=RegK.Y1+RegK.KA*RegK.E0-RegK.KB*RegK.E1+RegK.KC*RegK.E2;											//Vypocet trva cca. 1300us
											if((int)RegK.Y0<=(RegK.Servo_Min*K)) RegK.Y0=RegK.Servo_Min*K;
											if((int)RegK.Y0>=(RegK.Servo_Max*K)) RegK.Y0=RegK.Servo_Max*K;											
											//ReceivedMessage->CH[tex]=RegK.Tlimit;											//Test na vypnutie ...
											if(ReceivedMessage->CH[tex]>RegK.Tlimit)									//Tlimit>13C
											 {											  
											  RegK.SetPosition=RegK.Servo_Min;												//Tlimit>13C uberem servo na minimum a task PUMPSK ho vypne po 10 minutach ...
											 }
											  else 
												 {
												  RtxCompletion=os_check_task(PUMPSK,&RTX51_Task);
													switch(RTX51_Task.state)
													 {
													  case	K_READY		:
														case	K_BLOCKED	:	switch(Counter)
																							 {
																								case	1000	:	Counter=0x0000; RtxCompletion=os_send_signal(PUMPSK); break;		//Neposielam tak casto os_send_signal(),lebo to RTX zatazuje. Staci 2-10x do 10 minut ...
																								default			:	Counter++; break;																							//Pocitam tick-y ...
																							 }
																							break;
														case	K_DELETED	: RtxCompletion=os_create_task(PUMPSK); break;				//Ak task bol vypnuty tak sa dlho nekurilo a cerpadlo bolo odstavene ...
													 }
												  RegK.SetPosition=(int)RegK.Y0;
												 }
											RegK.E2=RegK.E1;
											RegK.E1=RegK.E0;
											RegK.Y1=RegK.Y0;
											break;
		 case	SIG_EVENT	:	RegK.KA=(RegK.Kp*(1.0+RegK.dT/(2.0*RegK.Ti)));								//Konstanta KA prirastkoveho regulatora
											RegK.KB=(RegK.Kp*(1.0-RegK.dT/(2.0*RegK.Ti)));								//Konstanta KB prirastkoveho regulatora
											RegK.KC=(RegK.Kp*(RegK.Td/RegK.dT));					     						//Konstanta KC prirastkoveho regulatora
											break;								
		}
	}
}

void Regulator_V(void) _task_ REGULATOR_V _priority_ 2
{
 signed char RtxCompletion;
 t_rtx_onetasktab RTX51_Task;
 unsigned int Counter;
 memcpy(&RegV,&FactoryV,sizeof(RegV));
/* 
 RegV.Reset='N';
 RegV.dT=RegdT;
 RegV.Tmin=0;
 RegV.Tmax=50;																								//Obmedzenie teploty vystupneho okruhu Tmin..Tmax, Tk je teplota kurenia ...
 RegV.Tutlm=50;																								//Nastavenie znizenej teploty T pre teplu vodu
 RegV.Tkomfort=55;																						//Nastavenie komfortnej teploty T pre teplu vodu
 RegV.Tlimit=13;																							//Od Tlimit=13C zacnem vykurovat ....
 //RegV.Tk=45;																									
 RegV.Kp=RegVKp;																							//Proporcionalna konstanta Kp
 RegV.Ti=RegVTi;																							//Integracna konstanta Ti, je potrebne ju prehodnotit pri zmene serva ...
 RegV.Td=RegVTd;																							//Derivacna konstanta Td, ovplyvnuje strmost narastu pri zmene reg. odchylky 
 RegV.E0=RegV.E1=RegV.E2=0;
 RegV.KA=(RegV.Kp*(1.0+RegV.dT/(2.0*RegV.Ti)));								//Konstanta KA prirastkoveho regulatora
 RegV.KB=(RegV.Kp*(1.0-RegV.dT/(2.0*RegV.Ti)));								//Konstanta KB prirastkoveho regulatora
 RegV.KC=(RegV.Kp*(RegV.Td/RegV.dT));					  							//Konstanta KC prirastkoveho regulatora 
 RegV.Y0=RegV.Y1=0.000;
 RegV.Servo_Min=0;																						//V sekundach !!!
 RegV.Servo_Max=36;																						//Natocenie o 180 za 36 sekund, Zdvih=12mm, Posun=3s/mm = 12*3=36s
 RegV.Pump=ON;																								//Zapnutie obehoveho cerpadla ... 
// memcpy(&RegV.Od,&FactoryV.Od,sizeof(RegV.Od));								//Kopirujem rozsah komfortu ...
// memcpy(&RegV.Do,&FactoryV.Do,sizeof(RegV.Do));								//Kopirujem rozsah komfortu ...
*/
 while(1)
  {
	 switch(RtxCompletion=os_wait(K_SIG+K_MBX+MBX_REG_V,WaitForEver,(unsigned int xdata*)&ReceivedMessage))
	  {
		 case	MSG_EVENT	:	RegV.deltaT=(RegV.Tkomfort-RegV.Tutlm);
											switch(RegV.Comfort)
											 {
												case	ON	:	RegV.E0=RegV.Tkomfort-ReceivedMessage->CH[tv];
																		RtxCompletion=os_check_task(PUMPSV,&RTX51_Task);
																		switch(RTX51_Task.state)
																		 {
																		  case	K_READY		:
																			case	K_BLOCKED	:	switch(Counter)
																												 {
																												  case	1000	:	Counter=0x0000; RtxCompletion=os_send_signal(PUMPSV); break;		//Neposielam tak casto os_send_signal(),lebo to RTX zatazuje. Staci 2-10x do 10 minut ...
																													default			:	Counter++; break;
																												 }
																												break;
																			case	K_DELETED	:	RtxCompletion=os_create_task(PUMPSV); break;				//Ak task bol vypnuty tak sa dlho nebola tepla voda a cerpadlo bolo odstavene ...
																		 }
																		break;
												case	OFF	: RegV.E0=RegV.Tutlm-ReceivedMessage->CH[tv]; break;
											 }											
											if(ReceivedMessage->CH[tv]>=RegV.Tmax) {RegV.Y0=RegV.Y1; RegV.E0=RegV.E1=RegV.E2=0;}	//Obmedzenie na teplotu Tmin..Tmax
											RegV.Y0=RegV.Y1+RegV.KA*RegV.E0-RegV.KB*RegV.E1+RegV.KC*RegV.E2;											//Vypocet trva cca. 1300us
											if((int)RegV.Y0<=(RegV.Servo_Min*K)) RegV.Y0=RegV.Servo_Min*K;
											if((int)RegV.Y0>=(RegV.Servo_Max*K)) RegV.Y0=RegV.Servo_Max*K;
											RegV.SetPosition=(int)RegV.Y0;
											RegV.E2=RegV.E1;
											RegV.E1=RegV.E0;
											RegV.Y1=RegV.Y0;
											break;
		 case	SIG_EVENT	:	RegV.KA=(RegV.Kp*(1.0+RegV.dT/(2.0*RegV.Ti)));								//Konstanta KA prirastkoveho regulatora
											RegV.KB=(RegV.Kp*(1.0-RegV.dT/(2.0*RegV.Ti)));								//Konstanta KB prirastkoveho regulatora
											RegV.KC=(RegV.Kp*(RegV.Td/RegV.dT));					 								//Konstanta KC prirastkoveho regulatora
											break;								
		}
	}
}

enum {Zero=0, Min=-1, Max=+1, Deathtime=+30};

sbit	Servo_k_Max	=	P1^0;
sbit	Servo_k_Min	=	P1^1;
sbit	PumpK				= P4^6;

void ServoK(void) _task_ SERVOK _priority_ 1
{
 signed char RtxCompletion,Actual0,Actual1;
 while(1)
  {
	 PumpK=RegK.Pump;
	 switch(RtxCompletion=os_wait(K_IVL+K_SIG,K*10,NULL))
	  {
		 case	TMO_EVENT	:	//LED=1;
											RegK.dPosition=RegK.SetPosition-RegK.ActualPosition;
											switch(Actual0=memcmp(&RegK.SetPosition,&RegK.ActualPosition,sizeof(RegK.ActualPosition)))
											 {
											  case	Zero	:	if(Actual0!=Actual1) {Servo_k_Max=Servo_k_Min=OFF; RtxCompletion=os_wait(K_IVL,Deathtime,NULL);}
																			break;
												case	Max		:	if(Actual0!=Actual1) {Servo_k_Min=OFF; RtxCompletion=os_wait(K_IVL,Deathtime,NULL); Servo_k_Max=ON;}
																			++RegK.ActualPosition;
																			break;
												case	Min		:	if(Actual0!=Actual1) {Servo_k_Max=OFF; RtxCompletion=os_wait(K_IVL,Deathtime,NULL); Servo_k_Min=ON;}
																			--RegK.ActualPosition;
																			break;
											 }
											Actual1=Actual0;
											//LED=0;
											break;
		 //case	SIG_EVENT	:	Servo_k_Max=ON;
											break;
		 default				:	break;
		}
	}
}

sbit	Servo_v_Max	=	P1^2;
sbit	Servo_v_Min	=	P1^3;
sbit	PumpV				= P4^7;

void ServoV(void) _task_ SERVOV _priority_ 1
{
 signed char RtxCompletion,Actual0,Actual1;
 while(1)
  {
	 PumpV=RegV.Pump;
	 switch(RtxCompletion=os_wait(K_IVL+K_SIG,K*10,NULL))
	  {
		 case	TMO_EVENT	:	//LED=1;
											RegV.dPosition=RegV.SetPosition-RegV.ActualPosition;
											switch(Actual0=memcmp(&RegV.SetPosition,&RegV.ActualPosition,sizeof(RegV.ActualPosition)))
											 {
											  case	Zero	:	if(Actual0!=Actual1) {Servo_v_Max=Servo_v_Min=OFF; RtxCompletion=os_wait(K_IVL,Deathtime,NULL);}
																			break;
												case	Max		:	if(Actual0!=Actual1) {Servo_v_Min=OFF; RtxCompletion=os_wait(K_IVL,Deathtime,NULL); Servo_v_Max=ON;}
																			++RegV.ActualPosition;
																			break;
												case	Min		:	if(Actual0!=Actual1) {Servo_v_Max=OFF; RtxCompletion=os_wait(K_IVL,Deathtime,NULL); Servo_v_Min=ON;}
																			--RegV.ActualPosition;
																			break;
											 }
											Actual1=Actual0;
											//LED=0;
											break;
		 //case	SIG_EVENT	:	Servo_k_Max=ON;
											break;
		 default				:	break;
		}
	}
}

unsigned char Menu=Info0;

void Clock(void) _task_ CLOCK _priority_ 1
{
 signed char RtxCompletion;
 unsigned int Counter=0x0000;
 Cas.DenNum=Pon;
 RtxCompletion=os_send_signal(DISPLAY);
 while(1)
  {
	 switch(RtxCompletion=os_wait(K_IVL,100,NULL))
	  {
		 case	TMO_EVENT	:	if(++Cas.Des==10)
											 {
											  Cas.Des=0x00;
												#ifdef DEMO
												if(++Counter>=3) {Menu++; Counter=0x0000;}
												#endif
												if(++Cas.Sek==60)
												 {
												  Cas.Sek=0x00;
													if(memcmp(&Cas,&RegK.Od[Cas.DenNum],sizeof(RegK.Od[Cas.DenNum]))==0x00) RegK.Comfort=ON;			//Result=-1 ak Cas<OdK, Result=0 ak Cas==OdK, Result=+1 ak Cas>OdK
													if(memcmp(&Cas,&RegK.Do[Cas.DenNum],sizeof(RegK.Do[Cas.DenNum]))==0x00) RegK.Comfort=OFF;
													if(memcmp(&Cas,&RegV.Od[Cas.DenNum],sizeof(RegV.Od[Cas.DenNum]))==0x00) RegV.Comfort=ON;			//Result=-1 ak Cas<OdV, Result=0 ak Cas==OdV, Result=+1 ak Cas>OdV												
													if(memcmp(&Cas,&RegV.Do[Cas.DenNum],sizeof(RegV.Do[Cas.DenNum]))==0x00) RegV.Comfort=OFF;
													if(++Cas.Min==60)
													 {
													  Cas.Min=0x00;
														if(++Cas.Hod==24)
														 {
														  Cas.Hod=0x00;
															if(++Cas.DenNum>Ned) Cas.DenNum=Pon;
														 }
													 }
												 }
											 }
											break;
		 case	SIG_EVENT	:	break;
		 case	INT_EVENT	:	break;
		}
	}
}

unsigned int index=0x0000;

void Display(void) _task_ DISPLAY _priority_ 0
{
 t_rtx_blockinfo xdata table;
 signed char RtxCompletion,teplota;
 unsigned int Message;
 unsigned char i;
 int args;
 RtxCompletion=os_set_slice(1536);
 RtxCompletion=os_create_pool(SizeMemBlock,MemoryPool,SizeMemPool); 				//Vytvorim MemoryPool v pamati XRAM pre datove struktury ...
 MessageToSend=os_get_block(SizeMemBlock);
 RtxCompletion=os_check_pool(SizeMemBlock,(t_rtx_blockinfo xdata*)&table);	//Je uspesne vytvoreny pool v pamati OK=0, NOT_OK=-1 ?
 RtxCompletion=os_create_pool(SizeEEBlock,EEMemoryPool,SizeEEPool); 				//Vytvorim EEMemoryPool v pamati XRAM pre datove struktury ...
 MsgEEToSendK=os_get_block(SizeEEBlock);
 MsgEEToSendV=os_get_block(SizeEEBlock);
 RtxCompletion=os_check_pool(SizeEEBlock,(t_rtx_blockinfo xdata*)&table);		//Je uspesne vytvoreny pool v pamati OK=0, NOT_OK=-1 ?
 RtxCompletion=os_create_task(REGULATOR_K);
 RtxCompletion=os_create_task(REGULATOR_V);
 RtxCompletion=os_create_task(SERVOK);
 RtxCompletion=os_create_task(SERVOV);
 RtxCompletion=os_create_task(CLOCK);
 RtxCompletion=os_create_task(PUMPSK);
 RtxCompletion=os_create_task(PUMPSV);
 RtxCompletion=os_create_task(ADC);
 sscanf(__TIME__,"%02bd:%02bd:%02bd",&Cas.Hod,&Cas.Min,&Cas.Sek);
 sscanf(__DATE2__,"%02bd/%02bd/%02bd",&Cas.Mes,&Cas.Den,&Cas.Rok);
 #ifdef SIMUL
 T=-Get_Int_Temp(AddrDS1624A);																							//Zistujem teplotu z DS1624 akoby to bola vonkajsia teplota !!!
 #endif
 RtxCompletion=os_attach_interrupt(4);
 LCD_Init();
 Init_Serial();
 printf("%s",display_menu);
 while(1)
  {
	 switch(RtxCompletion=os_wait(K_TMO+K_SIG+K_INT+K_MBX+MBX_DISPL,0xFE,&Message))
	  {
		 case	INT_EVENT	:	getline(&inline,sizeof(inline)); for (i = 0; inline[i] != 0; i++) inline[i] = toupper(inline[i]); for (i = 0; inline[i] == ' '; i++);
											switch(inline[i])
											 {
												case	'0'	:	Menu=Info0; break;
												case	'1'	:	Menu=Info1; break;
												case	'2'	:	Menu=Info2; break;
												case	'3'	:	Menu=Info3; break;
												case	'4'	:	Menu=Info4; break;
												case	'5'	:	Menu=Info5; break;
												case	'6'	:	Menu=InfoTe; break;
												case	'7'	:	Menu=InfoTs; break;
												case	'8'	:	Menu=Servis; break;
												case	'*'	:	memcpy(&RegK,&FactoryK,sizeof(RegK)); RtxCompletion=os_send_signal(REGULATOR_K);
																		memcpy(&RegV,&FactoryV,sizeof(RegV)); RtxCompletion=os_send_signal(REGULATOR_V);
																		break;
												case	'/'	:	switch(Menu)
																		 {
																		  case	SetKp	:	Menu=SetVp; break;
																			case	SetVp	: Menu=SetKp;	break;
																			default			:	Menu=SetKp;	break;
																		 }
																		break; 
												case	'K'	:	switch(Menu)
																		 {
																			case	SetKp	:	args=sscanf(&inline+1,"%f\n",&RegK.Kp); RtxCompletion=os_send_signal(REGULATOR_K); break;
																			case	SetVp	:	args=sscanf(&inline+1,"%f\n",&RegV.Kp); RtxCompletion=os_send_signal(REGULATOR_V); break;
																			default			:	Menu=SetKp; break;
																		 }																																				
																		break; 
												case	'I'	:	switch(Menu)
																		 {
																			case	SetKp	:	args=sscanf(&inline+1,"%f\n",&RegK.Ti); RtxCompletion=os_send_signal(REGULATOR_K); break;
																			case	SetVp	:	args=sscanf(&inline+1,"%f\n",&RegV.Ti); RtxCompletion=os_send_signal(REGULATOR_V); break;
																			default			:	Menu=SetKp; break;
																		 }
																		break;
												case	'D'	:	switch(Menu)
																		 {
																			case	SetKp	:	args=sscanf(&inline+1,"%f\n",&RegK.Td); RtxCompletion=os_send_signal(REGULATOR_K); break;
																			case	SetVp	:	args=sscanf(&inline+1,"%f\n",&RegV.Td); RtxCompletion=os_send_signal(REGULATOR_V); break;
																			default			:	Menu=SetKp; break;
																		 }
																		break;
												case	'V'	:	Menu=SetdT;
																		args=sscanf(&inline+1,"%f\n",&RegK.dT); 
																		if(RegK.dT<=0.010) RegK.dT=0.010;
																		if(RegK.dT>=0.254) RegK.dT=0.254;
																		RegV.dT=RegK.dT;
																		RtxCompletion=os_send_signal(REGULATOR_K);
																		RtxCompletion=os_send_signal(REGULATOR_V);
																		break;
												case	'X'	:	args=sscanf(&inline+1,"%bd\n",&RegK.Vykurovacia_Krivka);
																		if(RegK.Vykurovacia_Krivka<=0) RegK.Vykurovacia_Krivka=0;
																		if(RegK.Vykurovacia_Krivka>13) RegK.Vykurovacia_Krivka=13;
																		//args=sscanf(&inline+1,"%bd\n",&RegV.Vykurovacia_Krivka);
																		break;
												case	'Y'	:	args=sscanf(&inline+1,"%bd.%bd.%bd.%bd\n",&Cas.Den,&Cas.Mes,&Cas.Rok,&Cas.DenNum); break;
												case	'T'	:	args=sscanf(&inline+1,"%02bd:%02bd:%02bd\n",&Cas.Hod,&Cas.Min,&Cas.Sek); break;
												case	'R'	: args=sscanf(&inline+1,"%s\n",&RegK.Reset);
																		switch(RegK.Reset)
																		{
																		 case	'Y'	:	
																		 case	'A'	:	printf("*************************\r\n");
																								printf("* !!! Reset systemu !!! *\r\n");
																								printf("*************************\r\n");
																								Reset(); break;
																		 default	: break;
																		}																		
																		break;
/*												case	'A'	: printf("Nastav den 1..7 [Pon..Ned]\n");
																		day=getkey();
																		getline(&inline,sizeof(inline)); for (i = 0; inline[i] != 0; i++) inline[i] = toupper(inline[i]); for (i = 0; inline[i] == ' '; i++);
																		args=sscanf(&inline+1,"%02bd:%02bd\n",&OdK[day+1].Hod,&OdK[day+1].Min); break;*/
											}
											printf("%s",display_menu);
											break;
		 case	MSG_EVENT	:	break;
		 case	TMO_EVENT	:	switch(Menu)
											 {
												case 		Info0	:	LCD_Goto(Riadok1);
																				sprintf(String,"%02bd:%02bd:%02bd  %02bd.%02bd.%4d\n",Cas.Hod,Cas.Min,Cas.Sek,Cas.Den,Cas.Mes,Cas.Rok+2000);
																				LCD_Write_String(String);
																				LCD_Goto(Riadok2);
																				sprintf(String,"Tku=%+03d'C Tzi=%+03d'C%c\n",Value.CH[tk],(int)Ekviterm[RegK.Vykurovacia_Krivka][Value.CH[tex]+50],(Servo_k_Max==ON)?'+':(Servo_k_Min==ON)?'-':' ');
																				LCD_Write_String(String);
																				LCD_Goto(Riadok3);
																				sprintf(String,"Tex=%+03d'C Tks=%+03d'C\n",Value.CH[tex],Value.CH[tks]);
																				LCD_Write_String(String);
																				LCD_Goto(Riadok4);
																				sprintf(String,"Srk=%03d%c  Srv=%03d%c\n",(int)(100*RegK.ActualPosition/(RegK.Servo_Max*K)),'%',(int)(100*RegV.ActualPosition/(RegV.Servo_Max*K)),'%');
																				LCD_Write_String(String);																				
																				///Menu=Mnu;
																				break;
												case		Info1	:	LCD_Goto(Riadok1);
																				sprintf(String,"Kurenie Tzi=%+03d'C\n",(int)Ekviterm[RegK.Vykurovacia_Krivka][Value.CH[tex]+50]);
																				LCD_Write_String(String);
																				LCD_Goto(Riadok2);
																				Bar((int)(20*((int)Ekviterm[RegK.Vykurovacia_Krivka][Value.CH[tex]+50])/100));
																				LCD_Write_String(String);
																				LCD_Goto(Riadok3);
																				sprintf(String,"Kurenie Tku=%+03d'C%c\n",Value.CH[tk],(Servo_k_Max==ON)?'+':(Servo_k_Min==ON)?'-':' ');
																				LCD_Write_String(String);
																				LCD_Goto(Riadok4);
																				Bar((int)(20*Value.CH[tk]/100));
																				LCD_Write_String(String);
																				//Menu=Mnu;
																				break;
												case		Info2	:	LCD_Goto(Riadok1);
																				sprintf(String,"%02bd:%02bd:%02bd  %02bd.%02bd.%4d\n",Cas.Hod,Cas.Min,Cas.Sek,Cas.Den,Cas.Mes,Cas.Rok+2000);
																				LCD_Write_String(String);
																				LCD_Goto(Riadok2);
																				sprintf(String,"Tkf=%+03d'C Tut=%+03d'C%c\n",RegV.Tkomfort,RegV.Tutlm,(Servo_v_Max==ON)?'+':(Servo_v_Min==ON)?'-':' ');
																				LCD_Write_String(String);
																				LCD_Goto(Riadok3);
																				sprintf(String,"Tex=%+03d'C Ttv=%+03d'C\n",Value.CH[tex],Value.CH[tv]);
																				LCD_Write_String(String);
																				LCD_Goto(Riadok4);
																				sprintf(String,"Srk=%03d%c  Srv=%03d%c\n",(int)(100*RegK.ActualPosition/(RegK.Servo_Max*K)),'%',(int)(100*RegV.ActualPosition/(RegV.Servo_Max*K)),'%');
																				LCD_Write_String(String);
																				//Menu=Mnu;
																				break;
													case	Info3	:	LCD_Goto(Riadok1);
																				sprintf(String,"Servo ohrev   %03d%c%c\n",(int)(100*RegK.ActualPosition/(RegK.Servo_Max*K)),'%',(Servo_k_Max==ON)?'+':(Servo_k_Min==ON)?'-':' ');
																				LCD_Write_String(String);
																				LCD_Goto(Riadok2);
																				Bar((int)(20*RegK.ActualPosition/(RegK.Servo_Max*K)));
																				LCD_Write_String(String);
																				LCD_Goto(Riadok3);
																				sprintf(String,"Servo voda    %03d%c%c\n",(int)(100*RegV.ActualPosition/(RegV.Servo_Max*K)),'%',(Servo_v_Max==ON)?'+':(Servo_v_Min==ON)?'-':' ');
																				LCD_Write_String(String);
																				LCD_Goto(Riadok4);
																				Bar((int)(20*RegV.ActualPosition/(RegV.Servo_Max*K)));
																				LCD_Write_String(String);
																				//Menu=Mnu;
																				break;
													case	Info4	:	LCD_Goto(Riadok1);
																				sprintf(String,"  Zaloha do EEPROM\n");
																				LCD_Write_String(String);
																				LCD_Goto(Riadok4);
																				sprintf(String,"%s\n"," ! Prosim cakajte !");
																				LCD_Write_String(String);
																				RtxCompletion=os_wait(K_TMO,0,NULL);
																				memcpy(MsgEEToSendK,&RegK,SizeEEBlock);
																				memcpy(MsgEEToSendV,&RegV,SizeEEBlock);
																				for(index=0x0000; index<SizeEEBlock; index++) 
																				 {
																					Write_Eprom_AT24C32(AddrMC24C32,index,MsgEEToSendK[index]);
																					LCD_Goto(Riadok2);
																					Bar(20*index/(2*SizeEEBlock));
																					LCD_Write_String(String);
																					LCD_Goto(Riadok3);
																					sprintf(String,"       %3d%c\n",1+(int)(100*index/(2*SizeEEBlock)),'%');
																					LCD_Write_String(String);
																					#include <output.inc>
																					printf("%02bX",MsgEEToSendK[index]);
																				 }																		
																				for(index=SizeEEBlock; index<SizeEEBlock*2; index++)
																				 {
																					Write_Eprom_AT24C32(AddrMC24C32,index,MsgEEToSendV[index-SizeEEBlock]);
																					LCD_Goto(Riadok2);
																					Bar(20*index/(2*SizeEEBlock));
																					LCD_Write_String(String);
																					LCD_Goto(Riadok3);
																					sprintf(String,"       %3d%c\n",1+(int)(100*index/(2*SizeEEBlock)),'%');
																					LCD_Write_String(String);
																					#include <output.inc>		
																					printf("%02bX",MsgEEToSendV[(index-SizeEEBlock)]);
																				 }
																				printf("\n");  
																				Menu=Info0;
																				break;
													case	Info5:	LCD_Goto(Riadok1);
																				sprintf(String,"  Obnova z EEPROM\n");
																				LCD_Write_String(String);
																				LCD_Goto(Riadok4);
																				sprintf(String,"%s\n"," ! Prosim cakajte !");
																				LCD_Write_String(String);
																				printf("EEPROM kurenie:\r\n");
																				for(index=0x0000; index<SizeEEBlock; index++) 
																				 {
																					MsgEEToSendK[index]=(unsigned char)Read_Eprom_AT24C32(AddrMC24C32,index);
																					LCD_Goto(Riadok2);
																					Bar(0+20*index/(2*SizeEEBlock));
																					LCD_Write_String(String);
																					LCD_Goto(Riadok3);
																					sprintf(String,"       %3d%c\n",1+(int)(100*index/(2*SizeEEBlock)),'%');
																					LCD_Write_String(String);
																					#include <output.inc>
																					printf("%02bX",MsgEEToSendK[index]);
																				 }
																				printf("\n");  
																				memcpy(&RegK,MsgEEToSendK,SizeEEBlock);
																				RtxCompletion=os_send_signal(REGULATOR_K);
																				LCD_Goto(Riadok4);
																				sprintf(String,"%s\n"," ! Prosim cakajte !");
																				LCD_Write_String(String);
																				printf("EEPROM tepla voda:\r\n");
																				for(index=0x0000; index<SizeEEBlock; index++) 				
																				 {
																					MsgEEToSendV[index]=(unsigned char)Read_Eprom_AT24C32(AddrMC24C32,(SizeEEBlock+index));
																					LCD_Goto(Riadok2);
																					Bar(10+20*index/(2*SizeEEBlock));
																					LCD_Write_String(String);
																					LCD_Goto(Riadok3);
																					sprintf(String,"       %3d%c\n",50+(int)(100*index/(2*SizeEEBlock)),'%');
																					LCD_Write_String(String);
																					#include <output.inc>
																					printf("%02bX",MsgEEToSendV[index]);
																				 }
																				printf("\n");  
																				memcpy(&RegV,MsgEEToSendV,SizeEEBlock);
																				RtxCompletion=os_send_signal(REGULATOR_V);
																				Menu=Info0;
																				break;
													case	InfoTe:	LCD_Goto(Riadok1);
																				sprintf(String,"  Teplota vonkajsia\n");
																				LCD_Write_String(String);
																				LCD_Goto(Riadok2);
																				sprintf(String,"        %+02bd'C\n",(signed char)Value.CH[tex]);
																				LCD_Write_String(String);
																				LCD_Goto(Riadok3);
																				sprintf(String,"   Teplota systemu\n");
																				LCD_Write_String(String);
																				teplota=Get_Int_Temp(AddrDS1624A);
																				LCD_Goto(Riadok4);
																				sprintf(String,"        %+02bd'C\n",teplota);
																				LCD_Write_String(String);
																				RtxCompletion=os_wait(K_TMO,250,NULL);
																				RtxCompletion=os_wait(K_TMO,250,NULL);
																				RtxCompletion=os_wait(K_TMO,250,NULL);
																				break;
													case	InfoTs:	LCD_Goto(Riadok1);
																				sprintf(String,"  Teplota systemu\n");
																				LCD_Write_String(String);
																				teplota=Get_Int_Temp(AddrDS1624A);
																				LCD_Goto(Riadok2);
																				sprintf(String,"        %+02bd'C\n",teplota);
																				LCD_Write_String(String);
																				LCD_Goto(Riadok3);
																				Bar((int)(20*teplota/100));
																				LCD_Write_String(String);
																				LCD_Goto(Riadok4);
																				sprintf(String,"0'C      az    100'C");
																				LCD_Write_String(String);
																				RtxCompletion=os_wait(K_TMO,250,NULL);
																				RtxCompletion=os_wait(K_TMO,250,NULL);
																				RtxCompletion=os_wait(K_TMO,250,NULL);
																				//Menu=Mnu;
																				break;
													case	SetKp	:	
													case	SetKTi:	
													case	SetKTd:	LCD_Goto(Riadok1);
																				sprintf(String,"Parametre kurenia\n");
																				LCD_Write_String(String);
																				LCD_Goto(Riadok2);
																				sprintf(String,"Kp=%1.3E [-]\n",RegK.Kp);
																				LCD_Write_String(String);
																				LCD_Goto(Riadok3);
																				sprintf(String,"Ti=%1.3E [s]\n",RegK.Ti);
																				LCD_Write_String(String);
																				LCD_Goto(Riadok4);
																				sprintf(String,"Td=%1.3E [dT/s]\n",RegK.Td);
																				LCD_Write_String(String);
																				break;
													case	SetVp	:	
													case	SetVTi:	
													case	SetVTd:	LCD_Goto(Riadok1);
																				sprintf(String,"Parametre tep.vody\n");
																				LCD_Write_String(String);
																				LCD_Goto(Riadok2);
																				sprintf(String,"Kp=%1.3E [-]\n",RegV.Kp);
																				LCD_Write_String(String);
																				LCD_Goto(Riadok3);
																				sprintf(String,"Ti=%1.3E [s]\n",RegV.Ti);
																				LCD_Write_String(String);
																				LCD_Goto(Riadok4);
																				sprintf(String,"Td=%1.3E [dT/s]\n",RegV.Td);
																				LCD_Write_String(String);
																				break;													
													case	SetdT	:	LCD_Goto(Riadok1);
																				sprintf(String,"Vzorkovanie dT[s]\n");
																				LCD_Write_String(String);
																				LCD_Goto(Riadok2);
																				sprintf(String,"dT=%1.0f [ms]\n",RegK.dT*1000);
																				LCD_Write_String(String);
																				LCD_Goto(Riadok3);
																				sprintf(String,"dT=%1.3f [s]\n",RegK.dT);
																				LCD_Write_String(String);
																				LCD_Goto(Riadok4);
																				sprintf(String,"Zadaj v sekundach!\n");
																				LCD_Write_String(String);
																				break;
													case	Servis:	LCD_Goto(Riadok1);
																				sprintf(String,"  Servis do RS232\n");
																				LCD_Write_String(String);
																				LCD_Goto(Riadok4);
																				sprintf(String,"%s\n"," ! Prosim cakajte !");
																				LCD_Write_String(String);
																				for(index=0x0000; index<(2*SizeEEBlock); index++) 
																				 {
																				  #include <output.inc>
																					printf("%02bX",Read_Eprom_AT24C32(AddrMC24C32,index));
																					LCD_Goto(Riadok2);
																					Bar(20*index/(2*SizeEEBlock));
																					LCD_Write_String(String);
																					LCD_Goto(Riadok3);
																					sprintf(String,"       %3d%c\n",1+(100*index/(2*SizeEEBlock)),'%');
																					LCD_Write_String(String);
																				 }
																				printf("\n"); 
																				Menu=Info0;
																				break;
														default	:		Menu=Info0;	break;
											 }
											break;
	  }
	}
}

#define ToutK (10*60*(4*250))

void PumpsK(void) _task_ PUMPSK _priority_ 0
{
 signed char RtxCompletion;
 long int Counter;
 RegK.Pump=ON;
 while(1)
  {
	 switch(RtxCompletion=os_wait(K_TMO+K_SIG,250,NULL))
	  {
		 case	SIG_EVENT	:	Counter=0x0000; break;																	//Prijem signalu vynuluje premennu Counter a spusti znova odpocitavanie ...
		 case	TMO_EVENT	:	switch(Counter)
											 {
												case	ToutK	:	RegK.Pump=OFF;													//Neprisiel signal 10 min tak vypinam obehove cerpadlo ...
																			RtxCompletion=os_delete_task(PUMPSK); break;
												default			:	Counter++; break;
											 }
		}
	}
}

#define ToutV (20*60*(4*250))

void PumpsV(void) _task_ PUMPSV _priority_ 0
{
 signed char RtxCompletion;
 long int Counter;
 RegV.Pump=ON;
 while(1)
  {
	 switch(RtxCompletion=os_wait(K_TMO+K_SIG,250,NULL))
	  {
		 case	SIG_EVENT	:	Counter=0x0000; break;																	//Prijem signalu vynuluje premennu Counter a spusti znova odpocitavanie ...
		 case	TMO_EVENT	:	switch(Counter)
											 {
												case	ToutV	:	RegV.Pump=OFF;													//Neprisiel signal 20 min tak vypinam obehove cerpadlo ...
																			RtxCompletion=os_delete_task(PUMPSV); break;
												default			:	Counter++; break;
											 }
		}
	}
}

void main(void)
{
 signed char RtxCompletion;
 RtxCompletion=os_start_system(DISPLAY);
}